//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  DeepPink
#property indicator_color3  Gold
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                Tenkan          = 9;
extern int                Kijun           = 26;
extern int                Senkou          = 52;
extern ENUM_APPLIED_PRICE Price           = 0;
extern bool               ShowNeutral     = true;
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = false;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;

//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double UpH[];
double DnH[]; 
double NuH[];   
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);   
      SetIndexBuffer(2,NuH); SetIndexStyle(2,DRAW_HISTOGRAM);                          
      SetIndexBuffer(3,SpanA_Buffer);  
      SetIndexBuffer(4,SpanB_Buffer);  
      SetIndexBuffer(5,Tenkan_Buffer);                     
      SetIndexBuffer(6,Kijun_Buffer);   
      SetIndexBuffer(7,trend); 
     
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame==-99);
        TimeFrame         = MathMax(TimeFrame,_Period);
        SetIndexShift(3,Kijun * TimeFrame/Period());  
        SetIndexShift(4,Kijun * TimeFrame/Period());  
        SetIndexShift(5,Kijun * TimeFrame/Period());
        SetIndexShift(6,Kijun * TimeFrame/Period());        
     
      //
      //
      //
      //
      //
     
      IndicatorShortName(timeFrameToString(TimeFrame)+"  Kumo Breakout Histo"); 
return(0);
}  
     
int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { UpH[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        double price  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
        double thi    = High[i];
        double tlo    = Low[i];
        double tprice = 0;
        if (i >= Bars - Tenkan) continue;
        for (k = 1; k < Tenkan; k++)
        {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
       }
       
       if ((thi+tlo) > 0.0) 
            Tenkan_Buffer[i] = (thi + tlo)/2; 
       else Tenkan_Buffer[i] = 0;
       
       //
       //
       //
       //
       //
       
       double khi    = High[i];
       double klo    = Low[i];
       double kprice = 0;
       if  (i >= Bars - Kijun) continue;
       for (k = 1; k < Kijun; k++)
       {
          kprice = High[i+k];
          if(khi < kprice)  khi  = kprice;
         
          kprice = Low[i+k];
          if(klo  > kprice) klo  = kprice;
       }
        
       if ((khi+klo) > 0.0) 
            Kijun_Buffer[i] = (khi + klo)/2; 
       else Kijun_Buffer[i] = 0;
            
       //
       //
       //
       //
       //
        
       double shi    = High[i];
       double slo    = Low[i];
       double sprice = 0;
       if (i >= Bars - Senkou) continue;
       for (k = 1; k < Senkou; k++)
       {
          sprice = High[i+k];
          if(shi < sprice) shi  = sprice;
         
          sprice = Low[i+k];
          if(slo  > sprice) slo = sprice;
        }
        
           SpanA_Buffer[i] = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
           SpanB_Buffer[i] = (shi + slo)/2;
           
           //
           //
           //
           //
           //
           
           if (ShowNeutral)
                trend[i] = 0;
           else trend[i] = trend[i+1];
           UpH[i] = EMPTY_VALUE;
           DnH[i] = EMPTY_VALUE;
           NuH[i] = EMPTY_VALUE;
           
           if (Close[i] > MathMax(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun]))                                                                    trend[i] = 1; 
           if (Close[i] < MathMin(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun]))                                                                    trend[i] =-1; 
           if (Close[i] < MathMax(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun]) && Close[i] > MathMin(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun])) trend[i] = 0; 
           if (trend[i] == 1) UpH[i] = 1;
           if (trend[i] ==-1) DnH[i] = 1;
           if (trend[i] == 0) NuH[i] = 1;
         }
         manageAlerts();
         return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-98,0,0)*TimeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
            trend[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,Price,ShowNeutral,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,7,y);
            UpH[i]   = EMPTY_VALUE;
            DnH[i]   = EMPTY_VALUE;
            NuH[i]   = EMPTY_VALUE;
            if (trend[i] == 1) UpH[i] = 1;
            if (trend[i] ==-1) DnH[i] = 1;
            if (trend[i] == 0) NuH[i] = 1;   
      } 
return(0);         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)                          doAlert(whichBar,"price leaving Kumo cloud up");
         if (trend[whichBar] ==-1)                          doAlert(whichBar,"price leaving Kumo cloud down");
         if (trend[whichBar] == 0 && trend[whichBar+1]== 1) doAlert(whichBar,"price now in the cloud from above");
         if (trend[whichBar] ==-0 && trend[whichBar+1]==-1) doAlert(whichBar,"price now in the cloud from below");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Kumo Breakout Histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Kumo Breakout Histo "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}
               
     
  
  